#!/usr/bin/env perl

use lib './lib';
use strict;

use Dist;
use Storable;
use Time::HiRes qw/time/;
use DateTime;


my $start_time = time();
my $start_dt = DateTime->now();
my $cache = retrieve $ARGV[0];

my $first_count =()= grep {exists $cache->{jobstatus}{$_}{tested}} keys $cache->{jobstatus}->%*;

my $dists = 0+$cache->{modules}->@*;

while (1) {
  sleep(2);
  my $cache = eval {retrieve $ARGV[0]};
  next unless $cache;
  my $count =()= grep {exists $cache->{jobstatus}{$_}{tested}} keys $cache->{jobstatus}->%*;

  my $rate = ($count-$first_count)/(time()-$start_time);
  my $tocomplete = ($rate == 0? sub{-1} : sub{($dists-$count)/$rate})->();
  my $final_dt = $start_dt->clone()->add(seconds => $tocomplete);
  printf "%d/%d [%02.2f%%] %0.2f/s %s %0.2f\n", $count, $dists, 100*$count/$dists, $rate, $final_dt->iso8601, $tocomplete;
 
};
